﻿Option Explicit On
Imports System.IO
Imports SB_PictureTagger.Stammbaum

Public Class Main
    '###################################################################################################################
    '############### Main ##############################################################################################
    '###################################################################################################################

    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initial
        Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Clear()
        LoadConfigForm()

    End Sub 'Main_Load

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        'Speichere 
        SaveTagg()
        SaveConfigForm()
    End Sub 'Form1_Closing

    Private Sub LoadConfigForm()
        'Unsterstützte Formate
        ReDim Settings.PictureTagger.pub_aSupportedFiles(5)
        Settings.PictureTagger.pub_aSupportedFiles(0) = ".jpg"
        Settings.PictureTagger.pub_aSupportedFiles(1) = ".bmp"
        Settings.PictureTagger.pub_aSupportedFiles(2) = ".gif"
        Settings.PictureTagger.pub_aSupportedFiles(3) = ".png"
        Settings.PictureTagger.pub_aSupportedFiles(4) = ".jp2"
        Settings.PictureTagger.pub_aSupportedFiles(5) = ".tif"
        'Portable oder Nicht komming soon!

    End Sub 'LoadConfigForm
    Private Sub SaveConfigForm()
        'Wird noch Programmert, stürzt sich auf Stammbaum.Settings
        'Wie zuletz verwendetes Verzeichnis ...
    End Sub 'SaveConfigForm                                                                                                       ### in work ###


    '###################################################################################################################
    '############### Form1_Function-Tasks ##############################################################################
    '###################################################################################################################

    Private Function ChangesAreTrue() As Boolean
        'Setze Standardwert:
        ChangesAreTrue = False

        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Title <> tb_Bild_Title.Text Then ChangesAreTrue = True
        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Time <> tb_Bild_Time.Text Then ChangesAreTrue = True
        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Description <> rtb_Bild_Description.Text Then ChangesAreTrue = True

        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Title <> tb_Place_Title.Text Then ChangesAreTrue = True
        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Adresse <> tb_Place_Addresse.Text Then ChangesAreTrue = True
        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.GPS <> tb_Place_GPS.Text Then ChangesAreTrue = True
        If Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Description <> rtb_Place_Description.Text Then ChangesAreTrue = True

        'Wenn Markierungen geändert ... ### in work ###

    End Function 'PT_ChangesTrue = True; wenn ÄNDERUNGEN vorgenommen!

    '###################################################################################################################
    '############### Form1_Sub-Tasks ###################################################################################
    '###################################################################################################################

    Private Sub Clear_Form()
        tb_Bild_Time.Clear()
        tb_Bild_Title.Clear()
        tb_Place_Addresse.Clear()
        tb_Place_GPS.Clear()
        rtb_Bild_Description.Clear()
        rtb_Place_Description.Clear()

        'Entlehre Pfadangabe
        Label7.Text = Nothing

        'Entlehre PictureBox
        PictureBox1.Image = Nothing

        'Entlehre Speicher
        Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Clear()

        '### Lösche Markierungen ##             ### in work ###


    End Sub 'Resetet die Maske      -           -         -         -            -       -       -         -          -       -     ### in work ###


    Private Sub SaveTagg(Optional ByVal WithoutQestion = False)

        'Überprüfe ob Änderungen forgenommen #UND# Ob eine ID existiert #UND# Ob das Bild existiert
        If ChangesAreTrue() And (Settings.PictureTagger.Pub_oLoaded_TaggedIMG.ID <> "" Or Nothing) And System.IO.File.Exists(Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Path) Then

            'Überprüfe ob Tagg Speichern erlaubt
            If (cb_AutoSave.Checked Or WithoutQestion) Or (MessageBox.Show("Willst du die Änderungen Speichern?", "SB-PictureTagger", MessageBoxButtons.YesNo) = DialogResult.Yes) Then

                'TextBox sichern
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Title = tb_Bild_Title.Text
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Time = tb_Bild_Time.Text
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Description = rtb_Bild_Description.Text

                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Title = tb_Place_Title.Text
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Adresse = tb_Place_Addresse.Text
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.GPS = tb_Place_GPS.Text
                Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Description = rtb_Place_Description.Text

                'Lese Markierungen <-- in Planung (Fieleicht Überflüsig, jenachdem wie Markierungen angesteuert werden

                'In TaggSource speichern
                Stammbaum.Module.PictureTagger.PT_SaveTaggedIMG()

            End If

        End If
    End Sub 'Save Taggs when Changes are hapened


    Private Sub LoadTaggedIMG()
        
        'Textvelder Lehren
        Clear_Form()

        'Lade neues TaggedIMG mit Stammbaum.Module.PictureTagger Modul
        Stammbaum.Module.PictureTagger.PT_LoadTaggedIMG()

        'Zeigt den BildPfad unter PictureBox an
        Label7.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Path
        PictureBox1.Image = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Image

        'Befülle die TextBox-en
        tb_Bild_Title.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Title
        tb_Bild_Time.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Time
        rtb_Bild_Description.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Description

        tb_Place_Title.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Title
        tb_Place_Addresse.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Adresse
        tb_Place_GPS.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.GPS
        rtb_Place_Description.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Description

        'Erstelle Marks   ### in work ###

    End Sub 'LoadTaggedIMG -> Befülle TextBox-en [UND erstelle Markierungen]      -           -        -       -       -     -   ### in work ###

    '###################################################################################################################
    '############### Buton Events: Click ###############################################################################
    '###################################################################################################################


    Private Sub b_exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_exit.Click
        ' Programm Beenden
        Me.Close()
    End Sub 'Closing Programm = Save Taggs -> Save Configs from Form

    Private Sub b_loaddir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_loaddir.Click
        'Laden eines zu Taggenden Bilder-Verzeichnis
        Dim sTMP As String
        sTMP = Tools.Dialoge.FolderBrowserDialog()
        If Directory.Exists(sTMP) Then
            SaveTagg()
            Settings.PictureTagger.Pub_sPath = sTMP
            Stammbaum.Module.PictureTagger.PT_LoadVerzeichnis()
            LoadTaggedIMG()
        End If
    End Sub 'Öffne Ordner -> wenn Pfad OK -> Save Taggs -> Lade Verzeichnis -> Load Tagged IMG

    Private Sub b_reloaddir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_reloaddir.Click
        SaveTagg()
        Stammbaum.Module.PictureTagger.PT_LoadVerzeichnis()
        LoadTaggedIMG()
    End Sub 'Save Taggs -> Lade Verzeichnis -> Load Tagged IMG

    Private Sub b_save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_save.Click
        SaveTagg()
        LoadTaggedIMG()
    End Sub 'Wenn Änderung -> Save Taggs

    Private Sub b_next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_next.Click
        SaveTagg()
        If Settings.PictureTagger.Pub_nPfadeIndex < UBound(Settings.PictureTagger.Pub_aPfade) Then
            Settings.PictureTagger.Pub_nPfadeIndex += 1
        End If
        LoadTaggedIMG()
    End Sub 'Speichere Taggs -> Next Index -> Load Tagged IMG

    Private Sub b_last_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_last.Click
        SaveTagg()
        If Settings.PictureTagger.Pub_nPfadeIndex > 0 Then
            Settings.PictureTagger.Pub_nPfadeIndex = Settings.PictureTagger.Pub_nPfadeIndex - 1
        End If
        LoadTaggedIMG()
    End Sub 'Speichere Taggs -> Last Index -> Load Tagged IMG


    '###################################################################################################################
    '############### CheckBox Events: CheckStateChanged ################################################################
    '###################################################################################################################

    Private Sub cb_marks_visible_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        'Wenn cb_marks_visible=true then ZeichneMarks() ELSE VerstekeMarks()
    End Sub 'Visible/Hide Markierungen    -    -    -     ### in work ###

    '###################################################################################################################
    '############### NumericUpDown Events: ValueChanged ################################################################
    '###################################################################################################################

    Private Sub NumericUpDown_OrdnerTiefe_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles NumericUpDown_OrdnerTiefe.ValueChanged
        SaveTagg()
        Settings.PictureTagger.Pub_nOrdnerTiefe = NumericUpDown_OrdnerTiefe.Value
        Stammbaum.Module.PictureTagger.PT_LoadVerzeichnis()
        LoadTaggedIMG()
    End Sub ''Speichere Taggs -> Neue Ordner Tiefe -> Lade Verzeichnis -> Load Tagged IMG


End Class
